-------------------------------------------------------------------
-------	AddOn: [ReadySetDing]								-------
------- Author: Ketho (EU-Boulderfist Alliance)				-------
------- Date Created: 2010.01.04 (4 Januari 2010)			-------
-------														-------
-------	I'm a noob in Lua coding = (						-------
-------	This leveling AddOn's purpose is to compare			-------
-------	leveling speed and also make it more competitive	-------
-------------------------------------------------------------------
ReadySetDing = LibStub("AceAddon-3.0"):NewAddon("ReadySetDing", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
--+ A1) Remove Ace3 dependency and use libs instead ..
--+ 01) Add to saved variables; 02) Getnumpartymembers
--+ 03) Announce total time at lv80; 04) [Maybe] addon automatically stop working at 80/85(Cataclysm)
--+ 05) Party member ding

local options = {
    name = "ReadySetDing (Not Working*)",
    handler = ReadySetDing,
    type = 'group',
    args = {
		dingMsg = {
            type = "input",
            name = "Ding message",
            desc = "The ding message to be announced.",
            usage = "<Your message here>",
            get = "GetDingMessage",
            set = "SetDingMessage",
        },
		toggleGuildAnnounce = {
            type = "toggle",
            name = "Announce to Guild",
            get = "IsGuildAnnounce",
            set = "ToggleGuildAnnounce"
		},
		toggleOnOff = {
            type = "toggle",
            name = "Enable ReadySetDing",
            get = "IsAddOn",
            set = "ToggleAddOn",
        },
    },
}

local defaults = {
    profile = {
        AddOn = true,
        GuildAnnounce = true,
		dingMessage = "Ding! Level [x] in [timeDing]",
    },
}

function ReadySetDing:IsAddOn(info)
    return self.db.profile.AddOn
end
function ReadySetDing:ToggleAddOn(info, value)
    self.db.profile.AddOn = value
end

function ReadySetDing:IsGuildAnnounce(info)
    return self.db.profile.GuildAnnounce
end
function ReadySetDing:ToggleGuildAnnounce(info, value)
    self.db.profile.GuildAnnounce = value
end

function ReadySetDing:GetDingMessage(info)
    return self.db.profile.dingMessage
end
function ReadySetDing:SetDingMessage(info, newValue)
    self.db.profile.dingMessage = newValue
end
------
function ReadySetDing:RSD_Toggle()
	if		(RSD_Toggle == true) then	RSD_Toggle = false;	ChatFrame1:AddMessage("\124cffFFFF3F[ReadySetDing]\124r: \124cffFF2424Disabled\124r");
	elseif	(RSD_Toggle == false) then	RSD_Toggle = true;	ChatFrame1:AddMessage("\124cffFFFF3F[ReadySetDing]\124r: \124cffB6CA00Enabled\124r");
	end
end
function ReadySetDing:RSD_guildToggle()
	if		(RSD_guildToggle == true) then	RSD_guildToggle = false;	ChatFrame1:AddMessage("\124cffFFFF3F[ReadySetDing]\124r: Guild Announce \124cffFF2424Disabled\124r");
	elseif	(RSD_guildToggle == false) then	RSD_guildToggle = true;		ChatFrame1:AddMessage("\124cffFFFF3F[ReadySetDing]\124r: Guild Announce \124cffB6CA00Enabled\124r");
	end
end
----------------------------------------------------------------------------------------------------------------------------------------------------------------------
	--- OnInitialize(), OnEnable(), OnDisable() ---
function ReadySetDing:OnInitialize()	-- Called when the addon is loaded
	self.db = LibStub("AceDB-3.0"):New("ReadySetDingDB", defaults, "Default")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("ReadySetDing", options, {"ReadySetDing"})
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("ReadySetDing")
--	ReadySetDing.message = "test options..." -- what message ???
	
	self:RegisterChatCommand("rsd", "RSD_Toggle")
	self:RegisterChatCommand("rsdguild", "RSD_guildToggle")

	SetCVar("cameraDistanceMax",50);	-- Max Camera Distance ...
end

function ReadySetDing:OnEnable()	-- Called when the addon is enabled
	--- Register Events ---
	self:RegisterEvent("PLAYER_LEVEL_UP");
	self:RegisterEvent("TIME_PLAYED_MSG");
	self:RegisterEvent("GUILD_ROSTER_UPDATE");
	self:RegisterEvent("WORLD_MAP_UPDATE");
	self:RegisterEvent("PARTY_MEMBERS_CHANGED");

	--- Player Info ---
	playerName = UnitName("player"); -- Name of Player
--	englishFactionPlayer, localizedFactionPlayer = UnitFactionGroup("player");	-- Faction of Player
--	localizedClassPlayer, englishClassPlayer = UnitClass("player");	-- Class of Player
	playerLevel = UnitLevel("player"); -- Level of Player

	numGuildMembers = GetNumGuildMembers();
	RequestTimePlayed();	-- First timeplayed variable

	--- Options Variables ---
	RSD_Toggle = true;
	RSD_guildToggle = true;
	playerDinged = false;

	-- #Failed Slash Command --
--	SlashRSD = "/rsd";
--	SlashCmdList["RSD"] = SlashCommand_RSD2;
--	SlashCmdList["rsd"] = SlashCommand_RSD2(msg);
--	SLASH_MYADDON_SLASHCMD1 = '/rsdtest'
--	SlashCmdList_AddSlashCommand(rsd, SlashCommand_RSD2, ...)

	-- UnitXP("unit")
	-- UnitXPMax("unit")
	-- GetGuildRosterInfo(index)
	-- GetGuildRosterSelection()
	-- GetNumGuildMembers(offline)
	-- GuildRoster()
	-- IsInGuild()
	-- IsGuildLeader("name")
	-- SetGuildRosterSelection(index)
	-- SortGuildRoster("sort")
end

function ReadySetDing:OnDisable()	-- Called when the addon is disabled
    self:UnRegisterEvent("PLAYER_LEVEL_UP");
	self:UnRegisterEvent("TIME_PLAYED_MSG");
	self:UnRegisterEvent("GUILD_ROSTER_UPDATE");
	self:UnRegisterEvent("WORLD_MAP_UPDATE");
	self:UnRegisterEvent("PARTY_MEMBERS_CHANGED");
	self:Print("[ReadySetDing]: Disabled (OnDisable)")
end
----------------------------------------------------------------------------------------------------------------------------------------------------------------------
function ReadySetDing:ChatCommand(input)	-- Process the slash command ('input' contains whatever follows the slash command)
    if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
    else
        LibStub("AceConfigCmd-3.0").HandleCommand(ReadySetDing, "ReadySetDing", "rsd", input)
    end
end
----------------------------------------------------------------------------------------------------------------------------------------------------------------------
function ReadySetDing:PLAYER_LEVEL_UP(event, ...)
	PLU_level, PLU_hp, PLU_mp, PLU_talentPoints, PLU_strength, PLU_agility, PLU_stamina, PLU_intellect, PLU_spirit = select(1, ...);
	if (RSD_Toggle == true) then -- [ON / OFF] Check
	playerDinged = true;
	RequestTimePlayed(); --> "TIME_PLAYED_MSG" event
	end
end

function ReadySetDing:TIME_PLAYED_MSG(event, ...)
	totalTimeLevel, currentTimeLevel = select(1, ...);
	if (RSD_Toggle == true) then -- [ON / OFF] Check
		if (playerDinged == false) then notDing_totalTimeLevel = totalTimeLevel; notDing_currentTimeLevel = currentTimeLevel;
		elseif (playerDinged == true) and ((currentTimeLevel >= 0) and (currentTimeLevel <= 5)) then timeDing = ((totalTimeLevel - notDing_totalTimeLevel) + notDing_currentTimeLevel);
			if (instanceType == "none") then
				if (numPartyMembers) and (numPartyMembers >= 1) then	SendChatMessage("Ding! Level "..PLU_level.." in "..ReadySetDing_timeToString(timeDing)..".", "PARTY");
				else	SendChatMessage("Ding! Level "..PLU_level.." in "..ReadySetDing_timeToString(timeDing)..".", "SAY");
				end
			elseif (instanceType == "party") then	SendChatMessage("Ding! Level "..PLU_level.." in "..ReadySetDing_timeToString(timeDing)..".", "PARTY");
			elseif (instanceType == "pvp") then	SendChatMessage("Ding! Level "..PLU_level.." in "..ReadySetDing_timeToString(timeDing)..".", "BATTLEGROUND");
			end
			if (IsInGuild() == 1) and (RSD_guildToggle == true) then	SendChatMessage("Ding! Level "..PLU_level.." in "..ReadySetDing_timeToString(timeDing)..".", "GUILD");
			end
			playerDinged = false; notDing_totalTimeLevel = nil; notDing_currentTimeLevel = nil;
		--	ChatFrame1:AddMessage("Total time played: "..totalTimeLevel..", Time played this level: "..currentTimeLevel.."");
		end
	end
end

function ReadySetDing:GUILD_ROSTER_UPDATE()
	if (IsInGuild() == 1) then
		for i = 1, numGuildMembers do
			local GGRI_name, GGRI_rank, GGRI_rankIndex, GGRI_level, GGRI_class, GGRI_zone, GGRI_note, GGRI_officernote, GGRI_online, GGRI_status, GGRI_classFileName = GetGuildRosterInfo(i);
			GuildRosterInfo = GGRI_name.."["..i.."]-"..GGRI_level;
		--	savedNameLevel..i = GGRI_name.."-"..GGRI_level;
		end
	end
end

function ReadySetDing:WORLD_MAP_UPDATE()
	inInstance, instanceType = IsInInstance()
end

function ReadySetDing:PARTY_MEMBERS_CHANGED()
	numPartyMembers = GetNumPartyMembers();
end

function ReadySetDing_timeToString(time)
	local seconds = mod(floor(time),60);
	local minutes = mod(floor(time/60),60);
	local hours = mod(floor(time/3600),24);
	local days = floor(time/(86400));
	if (time < 60) then
		if		(seconds ~= 1)					then return ""..seconds.." seconds";
		elseif	(seconds == 1)					then return ""..seconds.." second";
		end
	elseif (time >= 60 and time < 3600) then
		if		(minutes ~= 1 and seconds ~= 1)	then return ""..minutes.." minutes, "..seconds.." seconds";
		elseif	(minutes == 1 and seconds ~= 1)	then return ""..minutes.." minute, "..seconds.." seconds";
		elseif	(minutes ~= 1 and seconds == 1)	then return ""..minutes.." minutes, "..seconds.." second";
		elseif	(minutes == 1 and seconds == 1)	then return ""..minutes.." minute, "..seconds.." second";
		end
	elseif (time >= 3600 and time < 86400) then
		if		(hours ~= 1 and minutes ~= 1)	then return ""..hours.." hours, "..minutes.." minutes";
		elseif	(hours == 1 and minutes ~= 1)	then return ""..hours.." hour, "..minutes.." minutes";
		elseif	(hours ~= 1 and minutes == 1)	then return ""..hours.." hours, "..minutes.." minute";
		elseif	(hours == 1 and minutes == 1)	then return ""..hours.." hour, "..minutes.." minute";
		end
	elseif (time >= 86400) then
		if		(days ~= 1 and hours ~= 1)		then return ""..days.." days, "..hours.." hours ..";
		elseif	(days == 1 and hours ~= 1)		then return ""..days.." day, "..hours.." hours ..";
		elseif	(days ~= 1 and hours == 1)		then return ""..days.." days, "..hours.." hour ..";
		elseif	(days == 1 and hours == 1)		then return ""..days.." day, "..hours.." hour ..";
		end
	end
end
